@PS_open.pro

PRO statistic_2dPlot
COMMON STATISTIC_2DBLOCK, statistic_2dids

	wset,statistic_2dids.wid
	erase

	if statistic_2dids.back then begin
		im = statistic_2dids.im
		im = bytscl(im,min=statistic_2dids.backave)
		tv,im, $
		statistic_2dids.margin_l,statistic_2dids.margin_b, $
		xsize=statistic_2dids.xsize,ysize=statistic_2dids.ysize
	endif else $
	tvscl,statistic_2dids.im, $
		statistic_2dids.margin_l,statistic_2dids.margin_b, $
		xsize=statistic_2dids.xsize,ysize=statistic_2dids.ysize

	p1 = [float(statistic_2dids.margin_l)/ !d.x_size, $
	  float(statistic_2dids.margin_b)/ !d.y_size, $
	  float(!d.x_size - statistic_2dids.margin_r)/ !d.x_size, $
	  float(!d.y_size - statistic_2dids.margin_t)/ !d.y_size $
	  ]

	width = n_elements(statistic_2dids.x)
	height = n_elements(statistic_2dids.y)
	xrange = [0,width]
	yrange = [0,height]
	if statistic_2dids.versus eq 1 then begin
	xrange = [statistic_2dids.x(0),statistic_2dids.x(width-1)]
	yrange = [statistic_2dids.y(0),statistic_2dids.y(height-1)]
	end
	
	plot,/noerase,/nodata,pos=p1, [-1.,-1.], $
		title=' ',$
		xrange=xrange,yrange=yrange, xstyle=1,ystyle=1
	xyouts,!d.x_ch_size,!d.y_size -!d.y_ch_size,statistic_2dids.header(1),/device

	min_i = statistic_2dids.jmin MOD width
	min_j = statistic_2dids.jmin /width
	max_i = statistic_2dids.jmax MOD width
	max_j = statistic_2dids.jmax / width

	scan2d_ROI_field,statistic_2dids.ave,statistic_2dids.dev,$
		statistic_2dids.min,statistic_2dids.max, $
		min_i,min_j,max_i,max_j

	; ROI
;	st='ROI: IM[0:'+ strtrim(width-1,2)+', 0:'+ strtrim(height-1,2)+']'
;	WIDGET_CONTROL,statistic_2dids.roiid,SET_VALUE=st
	scan2d_ROI_LMB

	statistic_2dids.cross = 0
END

PRO boxregion,Event
COMMON STATISTIC_2DBLOCK, statistic_2dids

;	device,get_graphics_function=gmode
;	if gmode eq 6 then begin
;	xbox = [statistic_2dids.x1,statistic_2dids.x2,statistic_2dids.x2]
;	ybox = [statistic_2dids.y1,statistic_2dids.y1,statistic_2dids.y2]
;	xbox = xbox + statistic_2dids.margin_l
;	ybox = ybox + statistic_2dids.margin_b
;	plots,xbox,ybox,/device,thick=2
;	xbox = [statistic_2dids.x1,statistic_2dids.x1,statistic_2dids.x2]
;	ybox = [statistic_2dids.y1,statistic_2dids.y2,statistic_2dids.y2]
;	xbox = xbox + statistic_2dids.margin_l
;	ybox = ybox + statistic_2dids.margin_b
;	plots,xbox,ybox,/device,thick=2
;	endif else device,set_graphics_function=6

	wset,statistic_2dids.wid
	tv,statistic_2dids.pixmap,statistic_2dids.margin_l,statistic_2dids.margin_b

device,set_graphics_function=6
	wset,statistic_2dids.wid
	cursor,x1,y1,/device,/change ; /nowait

while(!err eq 1) do begin

	cursor,x2,y2,/device,/change,/nowait   ; draw continuously 

	plots,[x1,x2,x2],[y1,y1,y2],/device,thick=2
	plots,[x1,x1,x2],[y1,y2,y2],/device,thick=2

	plots,[x1,x2,x2],[y1,y1,y2],/device,thick=2
	plots,[x1,x1,x2],[y1,y2,y2],/device,thick=2
endwhile

statistic_2dids.x1 = x1 - statistic_2dids.margin_l
statistic_2dids.x2 = x2 - statistic_2dids.margin_l
if x2 lt x1 then begin 
	statistic_2dids.x1 = x2 - statistic_2dids.margin_l
	statistic_2dids.x2 = x1 - statistic_2dids.margin_l
end
statistic_2dids.y1 = y1 - statistic_2dids.margin_b
statistic_2dids.y2 = y2 - statistic_2dids.margin_b
if y2 lt y1 then begin 
	statistic_2dids.y1 = y2 - statistic_2dids.margin_b
	statistic_2dids.y2 = y1 - statistic_2dids.margin_b
end
	plots,[x1,x2,x2],[y1,y1,y2],/device,thick=2
	plots,[x1,x1,x2],[y1,y2,y2],/device,thick=2

device,set_graphics_function=3

END


PRO scan2d_ROI_MMB
COMMON STATISTIC_2DBLOCK, statistic_2dids

	wset,statistic_2dids.wid
	cursor,px2,py2,0,/device

	device,set_graphics_function=6
	if statistic_2dids.cross then begin
	plots,[statistic_2dids.cursor_x,statistic_2dids.cursor_x], $
	  [statistic_2dids.margin_b,!d.y_size-statistic_2dids.margin_t],/device
	plots,[statistic_2dids.margin_l,!d.x_size-statistic_2dids.margin_r], $
	  [statistic_2dids.cursor_y,statistic_2dids.cursor_y],/device
	end
	statistic_2dids.cross = 1
	statistic_2dids.cursor_x=px2
	statistic_2dids.cursor_y=py2
	plots,[px2,px2],[statistic_2dids.margin_b,!d.y_size-statistic_2dids.margin_t],/device
	plots,[statistic_2dids.margin_l,!d.x_size-statistic_2dids.margin_r],[py2,py2],/device
	device,set_graphics_function=3

	px2 = px2-statistic_2dids.margin_l
	py2 = py2-statistic_2dids.margin_b
	x2 = fix(px2/statistic_2dids.factor[0])
	y2 = fix(py2/statistic_2dids.factor[1]) ;+.5)
	if x2 ge statistic_2dids.width or $
		y2 ge statistic_2dids.height then begin
		res = dialog_message('Out of image area!',/error)
		return
		end
	if statistic_2dids.versus eq 1 then $
	st = 'CURSOR: X='+strtrim(statistic_2dids.x(x2),2)+', Y='+strtrim(statistic_2dids.y(y2),2)+',  Z='+strtrim(statistic_2dids.im0(x2,y2),2) else $
	st = 'CURSOR: X='+strtrim(x2,2)+', Y='+strtrim((y2),2)+',  Z='+strtrim(statistic_2dids.im0(x2,y2),2)
	WIDGET_CONTROL,statistic_2dids.cursor,SET_VALUE=st
	if statistic_2dids.debug then print,'cursor:i,j=',px2,py2,x2,y2
	statistic_2dids.cursor_i = x2
	statistic_2dids.cursor_j = y2

END

PRO scan2d_ROI_LMB
COMMON STATISTIC_2DBLOCK, statistic_2dids

	xbox = [statistic_2dids.x1,statistic_2dids.x2,statistic_2dids.x2]
	ybox = [statistic_2dids.y1,statistic_2dids.y1,statistic_2dids.y2]
	xbox = xbox + statistic_2dids.margin_l
	ybox = ybox + statistic_2dids.margin_b
	plots,xbox,ybox,/device,thick=2
	xbox = [statistic_2dids.x1,statistic_2dids.x1,statistic_2dids.x2]
	ybox = [statistic_2dids.y1,statistic_2dids.y2,statistic_2dids.y2]
	xbox = xbox + statistic_2dids.margin_l
	ybox = ybox + statistic_2dids.margin_b
	plots,xbox,ybox,/device,thick=2

statistic_2dids.xrange[0] = fix(statistic_2dids.x1/statistic_2dids.factor[0])
statistic_2dids.yrange[0] = fix(statistic_2dids.y1/statistic_2dids.factor[1])
statistic_2dids.xrange[1] = fix(statistic_2dids.x2/statistic_2dids.factor[0])
statistic_2dids.yrange[1] = fix(statistic_2dids.y2/statistic_2dids.factor[1]) ;+.5)

	if statistic_2dids.xrange[1] ge n_elements(statistic_2dids.x) then statistic_2dids.xrange[1] = n_elements(statistic_2dids.x) - 1
	if statistic_2dids.yrange[1] ge n_elements(statistic_2dids.y) then statistic_2dids.yrange[1] = n_elements(statistic_2dids.y) - 1

	if statistic_2dids.debug then begin
	print,'x1,y1',statistic_2dids.x1,statistic_2dids.y1
	print,'x2,y2',statistic_2dids.x2,statistic_2dids.y2
	print,'factor',statistic_2dids.factor
	print,'xrange',statistic_2dids.xrange
	print,'yrange',statistic_2dids.yrange
	end

	temp = statistic_2dids.im0(statistic_2dids.xrange(0):statistic_2dids.xrange(1),$
		statistic_2dids.yrange(0):statistic_2dids.yrange(1))
	if n_elements(temp) lt 2 then begin
	res = dialog_message('ROI is too small! Try again.',/Error)
	return
	end

	result = moment(temp,mdev=mdev,sdev=sdev)
	temp_max = max(temp,jmax)
	max_i = statistic_2dids.xrange[0] + $
	  jmax MOD (statistic_2dids.xrange[1]-statistic_2dids.xrange[0]+1) 
	max_j = statistic_2dids.yrange[0] + $
	  jmax / (statistic_2dids.xrange[1]-statistic_2dids.xrange[0]+1)
	temp_min = min(temp,jmin)
	min_i = statistic_2dids.xrange[0] + $
	  jmin MOD (statistic_2dids.xrange[1]-statistic_2dids.xrange[0]+1)
	min_j = statistic_2dids.yrange[0] + $
	  jmin / (statistic_2dids.xrange[1]-statistic_2dids.xrange[0]+1)

	statistic_2dids.min_i = min_i
	statistic_2dids.min_j = min_j
	statistic_2dids.max_i = max_i
	statistic_2dids.max_j = max_j
	statistic_2dids.roi_total = total(temp)
	statistic_2dids.roi_max = temp_max
	statistic_2dids.roi_min = temp_min
	statistic_2dids.roi_ave = result(0)
	statistic_2dids.roi_dev = sdev

	scan2d_ROI_field,result(0),sdev,temp_min,temp_max,min_i,min_j,max_i,max_j
	; ROI
  	st='ROI: IM['+strtrim(statistic_2dids.xrange(0),2)+':'+ $
			strtrim(statistic_2dids.xrange(1),2)+', '+ $
			strtrim(statistic_2dids.yrange(0),2)+':'+ $
			strtrim(statistic_2dids.yrange(1),2)+']'+ $
			',  Total='+strtrim(statistic_2dids.roi_total,2)
	WIDGET_CONTROL,statistic_2dids.roiid,SET_VALUE=st
END

PRO scan2d_ROI_field,ave,dev,tmin,tmax,min_i,min_j,max_i,max_j
COMMON STATISTIC_2DBLOCK, statistic_2dids

	WIDGET_CONTROL,statistic_2dids.aveid,SET_VALUE=ave
	WIDGET_CONTROL,statistic_2dids.devid,SET_VALUE=dev
	WIDGET_CONTROL,statistic_2dids.minid,SET_VALUE=tmin
	WIDGET_CONTROL,statistic_2dids.maxid,SET_VALUE=tmax

	if statistic_2dids.versus eq 0 then begin
	WIDGET_CONTROL,statistic_2dids.minxid,SET_VALUE=min_i
	WIDGET_CONTROL,statistic_2dids.minyid,SET_VALUE=min_j
	WIDGET_CONTROL,statistic_2dids.maxxid,SET_VALUE=max_i
	WIDGET_CONTROL,statistic_2dids.maxyid,SET_VALUE=max_j
	endif else begin
	WIDGET_CONTROL,statistic_2dids.minxid,SET_VALUE=statistic_2dids.x(min_i)
	WIDGET_CONTROL,statistic_2dids.minyid,SET_VALUE=statistic_2dids.y(min_j)
	WIDGET_CONTROL,statistic_2dids.maxxid,SET_VALUE=statistic_2dids.x(max_i)
	WIDGET_CONTROL,statistic_2dids.maxyid,SET_VALUE=statistic_2dids.y(max_j)
	end

END

PRO PDMENU13_Event, Event
COMMON STATISTIC_2DBLOCK, statistic_2dids

  CASE Event.Value OF

  'ROIFile.New...': BEGIN
	f = dialog_pickfile(filter='*roi.xdr',title='New ROI File',/WRITE)
	found = findfile(f)
	if found(0) ne '' then begin
		res=dialog_message('File already exists!!',/Error)
		return
	end
	if strtrim(f,2) ne '' then begin
	WIDGET_CONTROL,statistic_2dids.fileid,SET_VALUE=f
	statistic_2dids.file = f
	end
    END
  'ROIFile.Open...': BEGIN
	f = dialog_pickfile(filter='*roi.xdr',title='Pick ROI File',/MUST_EXIST,/WRITE)
	if strtrim(f,2) ne '' then begin
	WIDGET_CONTROL,statistic_2dids.fileid,SET_VALUE=f
	statistic_2dids.file = f
	end
	WIDGET_CONTROL,statistic_2dids.fileid,SET_VALUE=f
	statistic_2dids.file = f
    END
  ENDCASE
END


PRO PDMENU3_Event, Event
COMMON STATISTIC_2DBLOCK, statistic_2dids

  CASE Event.Value OF

  'RptFile.New...': BEGIN
    PRINT, 'Event for File.New...'
	f = dialog_pickfile(filter='*roi.rpt',title='ROI Report.New...',/WRITE)
	found = findfile(f)
	if found(0) ne '' then begin
		res=dialog_message('File already exists!!',/Error)
		return
	end
	if strtrim(f,2) ne '' then begin
	WIDGET_CONTROL,statistic_2dids.rptid,SET_VALUE=f
	statistic_2dids.rpt = f
	end
    END
  'RptFile.Open...': BEGIN
    PRINT, 'Event for File.Open...'
	f = dialog_pickfile(filter='*roi.rpt',title='ROI Report.Open...',/MUST_EXIST,/WRITE)
	if strtrim(f,2) ne '' then begin
	WIDGET_CONTROL,statistic_2dids.rptid,SET_VALUE=f
	statistic_2dids.rpt = f
	end
	WIDGET_CONTROL,statistic_2dids.rptid,SET_VALUE=f
	statistic_2dids.rpt = f
    END
  ENDCASE
END

PRO scan2d_ROI_Event, Event
COMMON STATISTIC_2DBLOCK, statistic_2dids

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 

  'STATISTIC_2DDRAW': BEGIN
	if (Event.PRESS eq 2) then begin
	scan2d_ROI_MMB
	return
	end

	if (Event.press eq 4) then begin
	scan2d_ROI_MMB
	statistic_2dPlot
	end

      if (Event.PRESS eq 1) then begin
	boxregion,Event
	scan2d_ROI_LMB
	return
	end

      END
  'STATISTIC_2DCLEAN': BEGIN
	statistic_2dids.x1=0
	statistic_2dids.y1=0
	statistic_2dids.x2=300
	statistic_2dids.y2=300
	statistic_2dPlot
      END
  'STATISTIC_2DFILE2': BEGIN
	WIDGET_CONTROL,statistic_2dids.rptid,GET_VALUE=f
	statistic_2dids.rpt = f
	END
  'STATISTIC_2DFILE': BEGIN
	WIDGET_CONTROL,statistic_2dids.fileid,GET_VALUE=f
	statistic_2dids.file = f
	END
  'STATISTIC_2DBACKFLD': BEGIN
	WIDGET_CONTROL,statistic_2dids.backid,GET_VALUE=ave
	statistic_2dids.backave = ave
	statistic_2dPlot
	END
  'STATISTIC_2DBACK': BEGIN
	statistic_2dids.back = Event.Index
	if statistic_2dids.back then begin
		WIDGET_CONTROL,statistic_2dids.backslid,SENSITIVE=1
		WIDGET_CONTROL,statistic_2dids.backid,SENSITIVE=1
	endif else begin
		WIDGET_CONTROL,statistic_2dids.backslid,SENSITIVE=0
		WIDGET_CONTROL,statistic_2dids.backid,SENSITIVE=0
	end
	statistic_2dPlot
	END
  'STATISTIC_2DBACKSLDR': BEGIN
	WIDGET_CONTROL,Event.ID,GET_VALUE=v
        statistic_2dids.backave=v
	WIDGET_CONTROL,statistic_2dids.backid,SET_VALUE=v
	statistic_2dPlot
      END
  'STATISTIC_2DVERSUS': BEGIN
	statistic_2dids.versus = Event.Index
if statistic_2dids.versus eq 0 then begin
WIDGET_CONTROL,statistic_2dids.minxid,SET_VALUE=statistic_2dids.min_i
WIDGET_CONTROL,statistic_2dids.minyid,SET_VALUE=statistic_2dids.min_j
WIDGET_CONTROL,statistic_2dids.maxxid,SET_VALUE=statistic_2dids.max_i
WIDGET_CONTROL,statistic_2dids.maxyid,SET_VALUE=statistic_2dids.max_j
	x2 = statistic_2dids.cursor_i
	y2 = statistic_2dids.cursor_j
	st = 'CURSOR: Ix='+strtrim(x2,2)+', Jy='+ $
		strtrim(y2,2)+',  Z='+ $
		strtrim(statistic_2dids.im0(x2,y2),2)
	WIDGET_CONTROL,statistic_2dids.cursor,SET_VALUE=st
endif else begin
WIDGET_CONTROL,statistic_2dids.minxid,SET_VALUE=statistic_2dids.x(statistic_2dids.min_i)
WIDGET_CONTROL,statistic_2dids.minyid,SET_VALUE=statistic_2dids.y(statistic_2dids.min_j)
WIDGET_CONTROL,statistic_2dids.maxxid,SET_VALUE=statistic_2dids.x(statistic_2dids.max_i)
WIDGET_CONTROL,statistic_2dids.maxyid,SET_VALUE=statistic_2dids.y(statistic_2dids.max_j)
	x2 = statistic_2dids.cursor_i
	y2 = statistic_2dids.cursor_j
	st = 'CURSOR: Ix='+strtrim(statistic_2dids.x(x2),2)+', Jy='+ $
	   	strtrim(statistic_2dids.y(y2),2)+',  Z='+ $
		strtrim(statistic_2dids.im0(x2,y2),2)
	WIDGET_CONTROL,statistic_2dids.cursor,SET_VALUE=st
end
	statistic_2dPlot

      END
  'STATISTIC_2DDONE': BEGIN
;	  device,set_graphics_function=3
	  WIDGET_CONTROL,Event.Top,/DESTROY
      END
  'STATISTIC_2DCOLOR': BEGIN
	XLOADCT,GROUP=Event.Top
      END
  'STATISTIC_2DREADROI': BEGIN
	found = findfile(statistic_2dids.file)
	if found(0) eq '' then begin
		res = dialog_message(['ROI file : ','',statistic_2dids.file, $
			'',' not found!'],/error)
		return
	end
	u_openr,unit,statistic_2dids.file,/XDR
	u_read,unit,x
	u_close,unit
	statistic_2dids.x1=x(0)
	statistic_2dids.x2=x(1)
	statistic_2dids.y1=x(2)
	statistic_2dids.y2=x(3)
	scan2d_ROI_LMB
      END
  'STATISTIC_2DSAVEROI': BEGIN
	x = [statistic_2dids.x1,statistic_2dids.x2,statistic_2dids.y1, $
		statistic_2dids.y2]
	u_openw,unit,statistic_2dids.file,/XDR
	u_write,unit,x
	u_close,unit
      END
  'STATISTIC_2DREPORTVIEW': BEGIN
	found = findfile(statistic_2dids.rpt)
	if found(0) eq '' then begin
		res = dialog_message(['ROI file : ','',statistic_2dids.rpt, $
			'',' not found!'],/error)
		return
	end
	xdisplayfile,statistic_2dids.rpt,GROUP=Event.Top
      END
  'STATISTIC_2DREPORT': BEGIN
	openw,1,statistic_2dids.rpt,ERROR=err,/append
	IF (err NE 0) then PRINTF, -2, !ERR_STRING
	printf,1,'Header: ',statistic_2dids.header
	printf,1,'ROI: [',strtrim(statistic_2dids.xrange(0),2),':', $
		strtrim(statistic_2dids.xrange(1),2),', ', $
		strtrim(statistic_2dids.yrange(0),2),':', $
		strtrim(statistic_2dids.yrange(1),2),'] ' 

	printf,1,'ave = ',statistic_2dids.roi_ave
	printf,1,'dev = ',statistic_2dids.roi_dev
	printf,1,'min = ',statistic_2dids.roi_min
	printf,1,'max = ',statistic_2dids.roi_max
	printf,1,'total = ',statistic_2dids.roi_total
	printf,1,''
	close,1
      END
  'STATISTIC_2DHELP': BEGIN
     st = [$
	'Drawing Area Mouse Button Functions:',$
	'         Left Button  - Press and move LMB to select the ROI, and ', $
	'                        release and move LMB showing the ROI box',  $
	'       Middle Button  - Get CURSOR values in index#/values', $
	'        Right Button  - Refresh the drawing area and ROI', $
	'Color... Button       - Run XLOADCT program to select different color tables',$
	'Refresh Button        - Refresh the drawing area and ROI', $
	'SaveROI Button        - Save new ROI in ROIFile',$
	'ReadROI Button        - Read old ROI from ROIFile',$
	'AppendRpt Button      - Append 2D statistic report data to RptFile',$
	'ViewRpt... Button     - View the 2D statistic RptFile',$
	'ROIFile Menu          - Select the desired ROIFile to be used ', $
	'ROIFile Field         - Enter/show the ROIFile used ', $
	'RptFile Menu          - Select the desired RptFile to be used ', $
	'RptFile Field         - Enter/show the RptFile used ', $
	'Data:IM[wd x ht]      - Shows the raw image dim and area total', $
	'ROI: Im[I1:I2, J1:J2] - ROI dim and area total', $ 
	'ROI Arerage:          - Shows the mean average of ROI',$
	'ROI Deviation:        - Shows the standard deviation of ROI', $
	'ROI Min:              - Shows the minimum value in ROI',$
	'       @Ix:           - Shows X index#/value of local Min', $
	'       @Jy:           - Shows Y index#/value of local Min', $
	'ROI Max:              - Shows the maximum value in ROI', $
	'       @Ix:           - Shows X index#/value of local Max', $
	'       @Jy:           - Shows Y index#/value of local Max', $
	'@Ix,Jy                - Index#/Value option of Ix,Jy value', $
	'Background: Yes/No    - Background modification Yes/No', $
	'           Set:       - Field to set background value',$
	'           Slider     - Controls the background field value', $
	'CURSOR:...            - MMB/RMB querys the X,Y,Z values at cursor',$
	'', $
	'Note:  Try to position the mouse at the center of the pixel area', $
	'       to avoid the round-off error in ROI upper bound Y index#.' $
	]
  	xdisplayfile,'',title='Help... 2D ROI',text=st, GROUP=Event.Top
      END
  ; Event for PDMENU3
  'PDMENU3': PDMENU3_Event, Event
  'PDMENU13': PDMENU13_Event, Event
  ENDCASE
END



PRO scan2d_ROI,im,x,y,ROI,debug=debug,header=header, GROUP=Group
COMMON STATISTIC_2DBLOCK, statistic_2dids
;
; optional ROI[x1,x2,y1,y2] specify initial ROI of pixels
;
  if n_params() lt 3 then return
  if XRegistered('scan2d_ROI') then $
	WIDGET_CONTROL,statistic_2dids.base,/DESTROY,bad_id=bad

  sz = size(im)
  
  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }

  result = moment(im,mdev=mdev,sdev=sdev)

  width = n_elements(x)
  height= n_elements(y)

  im_max = max(im,jmax)
  im_min = min(im,jmin)

xsize = 300
ysize = 300
nd = 1
if sz(0) eq 3 then nd = sz(3)
  statistic_2dids = { $
	nd: nd, $    ; all detector images array entered
	header: ['',''],$
	file: 'tmproi.xdr', $
	fileid: 0L, $
	rpt: 'tmproi.rpt', $
	rptid: 0L, $
	base: 0L, $
	wid : -1, $
	cursor: 0L, $
	cursor_x: 0., $
	cursor_y: 0., $
	cursor_i: 0, $
	cursor_j: 0, $
	cross: 0, $
	roiid : 0L, $
	drawid : 0L, $
	x1: 0,$
	x2: xsize,$
	y1: 0,$
	y2: ysize,$
	maxid : 0L, $
	maxxid : 0L, $
	maxyid : 0L, $
	minid : 0L, $ 
	minxid : 0L, $
	minyid : 0L, $
	aveid : 0L, $
	devid : 0L, $
	back: 0, $ 		;0-none,1-ave,2-userset
	backid: 0L, $
	backave: 0., $
	backslid: 0L, $
	im0: im,$ 
	x: x, $
	y: y, $
	im: congrid(im,xsize,ysize), $   ;400,400), $
	xsize : xsize, $
	ysize : ysize, $
	margin_l : 50, $
	margin_r : 50, $
	margin_b : 50, $
	margin_t : 50, $
	pixmap : make_array(xsize,ysize,/byte), $
	factor: [float(xsize)/width,float(ysize)/height], $
	xrange:[0,width-1], $
	yrange:[0,height-1], $
	width: width, $
	height: height, $
	versus : 0,$
	debug: 0, $
	max : im_max, $
	min : im_min, $
	jmax : jmax, $
	jmin : jmin, $
	max_i: jmax MOD width, $
	max_j: jmax / width, $
	min_i: jmin MOD width, $
	min_j: jmin / width, $
	roi_min: im_min, $
	roi_max: im_max, $
	roi_total: total(im), $
	roi_ave : result[0], $
	roi_dev : sdev, $
	total: total(im), $
	ave : result[0], $
	dev : sdev $
	}

  if keyword_set(header) then statistic_2dids.header = header

  if keyword_set(debug) then statistic_2dids.debug=1

  scan2d_ROI = WIDGET_BASE(GROUP_LEADER=Group, $
      TITLE='2D Statistic ROI', $
      COLUMN=1, $
      MAP=1, $
      UVALUE='scan2d_ROI')

  BASE2 = WIDGET_BASE(scan2d_ROI, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE2')

  DRAW3 = WIDGET_DRAW( BASE2, $
      BUTTON_EVENTS=1, $
      MOTION_EVENTS=1, $
      RETAIN=2, $
      UVALUE='STATISTIC_2DDRAW', $
      XSIZE=400, $
      YSIZE=400)

  BASE4 = WIDGET_BASE(BASE2, $
      COLUMN=1, $
      MAP=1, $
      UVALUE='BASE4')

  BASE5 = WIDGET_BASE(BASE4, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE5')

  BUTTON6 = WIDGET_BUTTON( BASE5, $
      UVALUE='STATISTIC_2DHELP', $
      VALUE='Help...')

  BUTTON8 = WIDGET_BUTTON( BASE5, $
      UVALUE='STATISTIC_2DCOLOR', $
      VALUE='Color...')

  BUTTON9 = WIDGET_BUTTON( BASE5, $
      UVALUE='STATISTIC_2DCLEAN', $
      VALUE='Refresh')

  BUTTON10 = WIDGET_BUTTON( BASE5, $
      UVALUE='STATISTIC_2DSAVEROI', $
      VALUE='SaveROI')

  BUTTON11 = WIDGET_BUTTON( BASE5, $
      UVALUE='STATISTIC_2DREADROI', $
      VALUE='ReadROI')

  BUTTON17 = WIDGET_BUTTON( BASE5, $
      UVALUE='STATISTIC_2DREPORT', $
      VALUE='AppendRpt')

  BUTTON18 = WIDGET_BUTTON( BASE5, $
      UVALUE='STATISTIC_2DREPORTVIEW', $
      VALUE='ViewRpt...')

  BUTTON7 = WIDGET_BUTTON( BASE5, $
      UVALUE='STATISTIC_2DDONE', $
      VALUE='Done')

  BASE4_file = WIDGET_BASE(BASE4, $
      ROW=1, /frame, $
      MAP=1, $
      UVALUE='BASE4_file')

MenuDesc165 = [ $
      { CW_PDMENU_S,       3, 'ROIFile' }, $ ;        0
        { CW_PDMENU_S,       0, 'New...' }, $ ;        1
        { CW_PDMENU_S,       0, 'Open...' } $ ;        2
  ]
  PDMENU13 = CW_PDMENU( BASE4_file, MenuDesc165, /RETURN_FULL_NAME, $
      UVALUE='PDMENU13')

statistic_filename = WIDGET_TEXT(BASE4_file,VALUE=statistic_2dids.file, $
		XSIZE=60, /EDITABLE, UVALUE='STATISTIC_2DFILE')

  BASE4_file2 = WIDGET_BASE(BASE4, $
      ROW=1, /frame, $
      MAP=1, $
      UVALUE='BASE4_file2')

MenuDesc167 = [ $
      { CW_PDMENU_S,       3, 'RptFile' }, $ ;        0
        { CW_PDMENU_S,       0, 'New...' }, $ ;        1
        { CW_PDMENU_S,       0, 'Open...' } $ ;        2
  ]
  PDMENU3 = CW_PDMENU( BASE4_file2, MenuDesc167, /RETURN_FULL_NAME, $
      UVALUE='PDMENU3')

statistic_filename2 = WIDGET_TEXT(BASE4_file2,VALUE=statistic_2dids.rpt, $
		XSIZE=60, /EDITABLE, UVALUE='STATISTIC_2DFILE2')
  st='Data: IM['+strtrim(width,2)+' x '+strtrim(height,2)+']'
  st=st + ', Total='+strtrim(statistic_2dids.total,2)
  Label1 = WIDGET_LABEL(BASE4,VALUE=st)

  st='Initial ROI: IM[0:'+strtrim(statistic_2dids.xrange[1],2)+ $
	', 0:'+strtrim(statistic_2dids.yrange[1],2)+']'+ $
	',  Total='+strtrim(statistic_2dids.total)
  Label2 = WIDGET_LABEL(BASE4,VALUE=st)

  FIELD27 = CW_FIELD( BASE4,VALUE=statistic_2dids.ave, $
      ROW=1, $
      FLOAT=1, /NOEDIT, $
      TITLE='ROI Average:', $
      UVALUE='STATISTIC_2DAVE')

  FIELD28 = CW_FIELD( BASE4,VALUE=statistic_2dids.dev, $
      ROW=1, $
      FLOAT=1, /NOEDIT, $
      TITLE='ROI Deviation:', $
      UVALUE='STATISTIC_2DDEV')

  BASE4_min = WIDGET_BASE(BASE4, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE4_min')

  FIELD16 = CW_FIELD( BASE4_min,VALUE=statistic_2dids.min, $
      ROW=1, $
      FLOAT=1, /NOEDIT, $
      TITLE='ROI Min:', $
      UVALUE='STATISTIC_2DMIN')

  FIELD17 = CW_FIELD( BASE4_min,VALUE=statistic_2dids.min_i, $
      ROW=1, $
      STRING=1, /NOEDIT, Xsize=3,$
      TITLE='@Ix:', $
      UVALUE='STATISTIC_2DXMIN')

  FIELD18 = CW_FIELD( BASE4_min,VALUE=statistic_2dids.min_j, $
      ROW=1, $
      STRING=1, /NOEDIT, xsize=3,$
      TITLE='@Jy:', $
      UVALUE='STATISTIC_2DYMIN')


  BASE4_max = WIDGET_BASE(BASE4, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE4_max')

  FIELD23 = CW_FIELD( BASE4_max,VALUE=statistic_2dids.max, $
      ROW=1, $
      FLOAT=1, /NOEDIT, $
      TITLE='ROI Max:', $
      UVALUE='STATISTIC_2DMAX')


  FIELD24 = CW_FIELD( BASE4_max,VALUE=statistic_2dids.max_i, $
      ROW=1, $
      STRING=1, /NOEDIT, xsize=3, $
      TITLE='@Ix:', $
      UVALUE='STATISTIC_2DXMAX')

  FIELD25 = CW_FIELD( BASE4_max,VALUE=statistic_2dids.max_j, $
      ROW=1, $
      STRING=1, /NOEDIT, xsize=3, $
      TITLE='@Jy:', $
      UVALUE='STATISTIC_2DYMAX')

Btns918 = ['Index #', 'Values']
position_versus = WIDGET_DROPLIST(BASE4, VALUE=Btns918, $
        UVALUE='STATISTIC_2DVERSUS', TITLE='@Ix,Jy')
WIDGET_CONTROL, position_versus, SET_DROPLIST_SELECT=statistic_2dids.versus

  BASE4_back = WIDGET_BASE(BASE4, $
      ROW=1, /frame, $
      MAP=1, $
      UVALUE='BASE4_back')

Btns928 = ['No', 'Yes']
back_versus = WIDGET_DROPLIST(BASE4_back, VALUE=Btns928, $
        UVALUE='STATISTIC_2DBACK', TITLE='Background:')
WIDGET_CONTROL, back_versus, SET_DROPLIST_SELECT=statistic_2dids.back

  FIELD27_back = CW_FIELD( BASE4_back,VALUE=statistic_2dids.backave, $
      ROW=1, $
      FLOAT=1, /RETURN_EVENTS, $
      TITLE='Set:', XSIZE=10, $
      UVALUE='STATISTIC_2DBACKFLD')
	WIDGET_CONTROL,FIELD27_back,SENSITIVE=0

  if statistic_2dids.max gt statistic_2dids.min then begin
  FSLID3 = CW_FSLIDER( BASE4_back, $
      MAXIMUM=statistic_2dids.max, $
      MINIMUM=statistic_2dids.min, $
      SUPPRESS=1, $
      UVALUE='STATISTIC_2DBACKSLDR', $
      VALUE=statistic_2dids.min)

      statistic_2dids.backslid = FSLID3 
	WIDGET_CONTROL,FSLID3,SENSITIVE=0
	end


  st='  '
  Label3 = WIDGET_LABEL(scan2d_ROI,VALUE=st,XSIZE=600,/align_left)


  statistic_2dids.base = scan2d_ROI
  statistic_2dids.cursor = Label3 
  statistic_2dids.roiid = Label2 
  statistic_2dids.drawid = DRAW3
  statistic_2dids.minid = FIELD16
  statistic_2dids.minxid = FIELD17
  statistic_2dids.minyid = FIELD18
  statistic_2dids.maxid = FIELD23
  statistic_2dids.maxxid = FIELD24
  statistic_2dids.maxyid = FIELD25
  statistic_2dids.aveid = FIELD27
  statistic_2dids.devid = FIELD28
  statistic_2dids.backid = FIELD27_back
  statistic_2dids.fileid = statistic_filename
  statistic_2dids.rptid = statistic_filename2

  WIDGET_CONTROL, scan2d_ROI, /REALIZE

  ; Get drawable window index

  COMMON DRAW3_Comm, DRAW3_Id
  WIDGET_CONTROL, DRAW3, GET_VALUE=DRAW3_Id

	statistic_2dPlot
	statistic_2dids.pixmap = tvrd(statistic_2dids.margin_l,statistic_2dids.margin_b,statistic_2dids.xsize,statistic_2dids.ysize)

 	statistic_2dids.wid = !d.window

  if n_elements(ROI) ge 4 then begin
	statistic_2dids.x1= roi(0)
	statistic_2dids.x2= roi(1)
	statistic_2dids.y1= roi(2)
	statistic_2dids.y2= roi(3)
	scan2d_ROI_LMB
  end
  XMANAGER, 'scan2d_ROI', scan2d_ROI
END
